#!/usr/bin/env bash

# Loading some test-generators utilities
source @abs_builddir@/test-generators-utilities

if [ "@NANOX_ENABLED@" = "no" ];
then
    gen_ignore_test "Nanos++ is disabled"
    exit
fi

if [ "$TEST_LANGUAGE" = "fortran" -a @FORTRAN_TESTS_ENABLED@ = no ];
then
    gen_ignore_test "Fortran tests are disabled"
    exit
fi

# Parsing the test-generator arguments
parse_arguments $@

if [ "$TG_ARG_OMPSS" = "yes" ]; then
    PROGRAMMING_MODEL="--ompss"
elif [ "$TG_ARG_OPENMP" = "yes" ]; then
    PROGRAMMING_MODEL="--openmp"
fi

if [ "$TG_ARG_CXX11" = "yes" ];
then
    if ! $(gcc_supports_cxx11);
    then
        gen_ignore_test "requires g++ 4.8 or better"
        exit
    fi
    CXX11_FLAG="-std=c++11"
fi

source @abs_builddir@/mercurium-libraries


cat <<EOF
NANOX_MCC="@abs_top_builddir@/src/driver/plaincxx --output-dir=@abs_top_builddir@/tests --profile=mcc --config-dir=@abs_top_builddir@/config --verbose --debug-flags=abort_on_ice"
NANOX_MCXX="@abs_top_builddir@/src/driver/plaincxx --output-dir=@abs_top_builddir@/tests --profile=mcxx --config-dir=@abs_top_builddir@/config --verbose ${CXX11_FLAG} --debug-flags=abort_on_ice"
NANOX_MFC="@abs_top_builddir@/src/driver/plaincxx --output-dir=@abs_top_builddir@/tests --profile=mfc --config-dir=@abs_top_builddir@/config -I@abs_top_builddir@/support/openmp/fortran --verbose --debug-flags=abort_on_ice"
EOF


COMMON_NANOX_CFLAGS="-DNANOX"

cat <<EOF
compile_versions="\${compile_versions} nanox_mercurium"

test_CC_nanox_mercurium="\${NANOX_MCC}"
test_CXX_nanox_mercurium="\${NANOX_MCXX}"
test_FC_nanox_mercurium="\${NANOX_MFC}"

test_FFLAGS="\${test_FFLAGS} --fpc=@abs_top_builddir@/src/driver/fortran/.libs/mf03-prescanner"

test_CFLAGS_nanox_mercurium="${PROGRAMMING_MODEL} ${COMMON_NANOX_CFLAGS}"
test_CXXFLAGS_nanox_mercurium="${PROGRAMMING_MODEL} ${COMMON_NANOX_CFLAGS}"
test_FFLAGS_nanox_mercurium="${PROGRAMMING_MODEL}"

test_LDFLAGS_nanox_mercurium="@abs_top_builddir@/lib/perish.o"

EOF

if [ "$TEST_LANGUAGE" = "c" ];
then
  if [ ! -z "@ICC@" ];
  then
cat <<EOF
NANOX_IMCC="@abs_top_builddir@/src/driver/plaincxx --output-dir=@abs_top_builddir@/tests --profile=imcc --config-dir=@abs_top_builddir@/config --verbose --debug-flags=abort_on_ice"
compile_versions="\${compile_versions} nanox_imcc"
test_CC_nanox_imcc="\${NANOX_IMCC}"
test_CFLAGS_nanox_imcc="${PROGRAMMING_MODEL} ${COMMON_NANOX_CFLAGS}"
test_LDFLAGS_nanox_imcc="@abs_top_builddir@/lib/perish.o"
EOF
  fi

  if [ ! -z "@XLC@" ];
  then
cat <<EOF
NANOX_XLMCC="@abs_top_builddir@/src/driver/plaincxx --output-dir=@abs_top_builddir@/tests --profile=xlmcc --config-dir=@abs_top_builddir@/config --verbose --debug-flags=abort_on_ice"
compile_versions="\${compile_versions} nanox_xlmcc"
test_CC_nanox_xlmcc="\${NANOX_XLMCC}"
test_CFLAGS_nanox_xlmcc="${PROGRAMMING_MODEL} ${COMMON_NANOX_CFLAGS}"
test_LDFLAGS_nanox_xlmcc="@abs_top_builddir@/lib/perish.o"
EOF
  fi
fi

if [ "$TEST_LANGUAGE" = "cpp" ];
then
  if [ ! -z "@ICPC@" ];
  then
cat <<EOF
NANOX_IMCXX="@abs_top_builddir@/src/driver/plaincxx --output-dir=@abs_top_builddir@/tests --profile=imcxx --config-dir=@abs_top_builddir@/config --verbose ${CXX11_FLAG} --debug-flags=abort_on_ice"
compile_versions="\${compile_versions} nanox_imcxx"
test_CXX_nanox_imcxx="\${NANOX_IMCXX}"
test_CXXFLAGS_nanox_imcxx="${PROGRAMMING_MODEL} ${COMMON_NANOX_CFLAGS}"
test_LDFLAGS_nanox_imcxx="@abs_top_builddir@/lib/perish.o"
EOF
  fi

  if [ ! -z "@XLCXX@" ];
  then
cat <<EOF
NANOX_XLMCXX="@abs_top_builddir@/src/driver/plaincxx --output-dir=@abs_top_builddir@/tests --profile=xlmcxx --config-dir=@abs_top_builddir@/config --verbose ${CXX11_FLAG} --debug-flags=abort_on_ice"
compile_versions="\${compile_versions} nanox_xlmcxx"
test_CXX_nanox_xlmcxx="\${NANOX_XLMCXX}"
test_CXXFLAGS_nanox_xlmcxx="${PROGRAMMING_MODEL} ${COMMON_NANOX_CFLAGS}"
test_LDFLAGS_nanox_xlmcxx="@abs_top_builddir@/lib/perish.o"
EOF
  fi
fi

if [ "$TEST_LANGUAGE" = "fortran" ];
then
  if [ ! -z "@IFORT@" ];
  then
cat <<EOF
NANOX_IMFC="@abs_top_builddir@/src/driver/plaincxx --output-dir=@abs_top_builddir@/tests --profile=imfc --config-dir=@abs_top_builddir@/config -I@abs_top_builddir@/support/openmp/fortran --verbose --debug-flags=abort_on_ice"
compile_versions="\${compile_versions} nanox_imfc"
test_FC_nanox_imfc="\${NANOX_IMFC}"
test_FFLAGS_nanox_imfc="${PROGRAMMING_MODEL}"
test_LDFLAGS_nanox_imfc="@abs_top_builddir@/lib/perish.o"
test_ENV_nanox_imfc="FOR_IGNORE_EXCEPTIONS=1"
EOF
  fi

  if [ ! -z "@XLF@" ];
  then
cat <<EOF
NANOX_XLMFC="@abs_top_builddir@/src/driver/plaincxx --output-dir=@abs_top_builddir@/tests --profile=xlmfc --config-dir=@abs_top_builddir@/config -I@abs_top_builddir@/support/openmp/fortran --verbose --debug-flags=abort_on_ice"
compile_versions="\${compile_versions} nanox_xlmfc"
test_FC_nanox_xlmfc="\${NANOX_XLMFC}"
test_FFLAGS_nanox_xlmfc="${PROGRAMMING_MODEL}"
test_LDFLAGS_nanox_xlmfc="@abs_top_builddir@/lib/perish.o"
EOF
  fi
fi

if [ ! -z "@NANOX_INSTRUMENTATION@" ];
then

cat <<EOF
compile_versions="\${compile_versions} nanox_instrument"

test_CC_nanox_instrument="\${NANOX_MCC}"
test_CXX_nanox_instrument="\${NANOX_MCXX}"
test_FC_nanox_instrument="\${NANOX_MFC}"

test_CFLAGS_nanox_instrument="\${test_CFLAGS_nanox_mercurium} --instrument"
test_CXXFLAGS_nanox_instrument="\${test_CXXFLAGS_nanox_mercurium} --instrument"
test_FFLAGS_nanox_instrument="\${test_FFLAGS_nanox_mercurium} --instrument"

test_LDFLAGS_nanox_instrument="@abs_top_builddir@/lib/perish.o"
EOF

fi

cat <<EOF
exec_versions="\${exec_versions} nanox_1thread nanox_2thread nanox_4thread"

test_ENV_nanox_1thread="OMP_NUM_THREADS='1'"
test_ENV_nanox_2thread="OMP_NUM_THREADS='2'"
test_ENV_nanox_4thread="OMP_NUM_THREADS='4'"
EOF
